﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;


namespace dataExtract
{
    class Program
    {
        private static Dictionary<string, List<double>> listOfVectorsForQuery = new Dictionary<string, List<double>>();
        private static int globalCount = 0;
        private static StreamWriter outputData = new StreamWriter("outputData.txt");
        private static StreamWriter listOfVectorOutput = new StreamWriter("outputVector2.txt");
        private static DateTime startDate = new DateTime(2011, 7, 16, 22, 0, 0);
        private static DateTime endDate = new DateTime(2011, 10, 24, 8, 0, 0);
        private static double summActivity = 0;
        private static TimeSpan tyme = endDate.Subtract(startDate);
        private static double numberOfHour = endDate.Subtract(startDate).TotalHours;
        private const double thresholdOfActivity = 0.0000005;

        private static void SummActivityOfQueries()
        {
            foreach (KeyValuePair<String, List<double>> pair in listOfVectorsForQuery)
            {
                summActivity += pair.Value.Sum();
            }
        }

        private static void ReduceRegularQuery()
        {
            int rightValue = 0;
            int leftValue = 0;
            List<string> listOfKey = new List<string>();
            List<double> sortedList = new List<double>();
            double treshold = 0.1;
            foreach (KeyValuePair<String, List<double>> pair in listOfVectorsForQuery)
            {
                foreach (double value in pair.Value)
                {
                    sortedList.Add(value);
                }
                sortedList.Sort();
                rightValue = pair.Value.Count * 3 / 4;
                leftValue = pair.Value.Count / 4;
                double diff = sortedList[rightValue] - sortedList[leftValue];
                if (diff < treshold)
                {
                    listOfKey.Add(pair.Key);
                }
                sortedList.Clear();
            }
            foreach (string key in listOfKey)
            {
                listOfVectorsForQuery.Remove(key);
            }

        }

        private static void ReduceNoActiveQuery()
        {
            summActivity = 0;
            double currentActivity = 0;
            SummActivityOfQueries();
            List<string> listOfKey = new List<string>();

            double treshold = 0.00005 * summActivity;//6

            foreach (KeyValuePair<String, List<double>> pair in listOfVectorsForQuery)
            {
                currentActivity = pair.Value.Sum();
                if (currentActivity < treshold)
                {
                    listOfKey.Add(pair.Key);
                }
            }
            foreach (string key in listOfKey)
            {
                listOfVectorsForQuery.Remove(key);
            }
        }
		
        private static void Normalization()
        {
            double norma = 0;

            double summ = 0;

            foreach (KeyValuePair<string, List<double>> pair in listOfVectorsForQuery)
            {
                summ = 0;
                for (int i = 0; i < pair.Value.Count; i++)
                {
                    summ += pair.Value[i] * pair.Value[i];
                }
                norma = Math.Sqrt(summ);
                for (int i = 0; i < pair.Value.Count; i++)
                {
                    pair.Value[i] = pair.Value[i] / norma;
                }
            }
        }

        private static List<double> CreateVectorByDayOfWeekVSHour(string queryId)
        {
            Dictionary<string, Dictionary<String, List<double>>> vector = new Dictionary<string, Dictionary<String, List<double>>>();
            List<double> vectorOfQuery = new List<double>(7);
            StreamReader inputData = new StreamReader("inputData.txt");

            string currentLine = String.Empty;
            int numberOfSemocolon = 0;
            int currentSymbol = 0;

            DateTime currentDate = new DateTime();
            string currentDateString = String.Empty;
            string currentHour = String.Empty;
            string currentTymeOfExecution = String.Empty;

            while ((currentLine = inputData.ReadLine()) != null)
            {
                while (currentSymbol < queryId.Length && currentLine[currentSymbol] == queryId[currentSymbol])
                {
                    currentSymbol++;
                }
                if (currentSymbol == queryId.Length)
                {
                    currentSymbol++;
                    if (currentLine[currentSymbol] == '.')
                    {
                        currentTymeOfExecution += '0';
                    }
                    while (currentLine[currentSymbol] != ';')
                    {
                        if (currentLine[currentSymbol] == '.')
                        {
                            currentTymeOfExecution += ',';
                        }
                        else
                        {
                            currentTymeOfExecution += currentLine[currentSymbol];
                        }
                        currentSymbol++;
                    }

                    while (numberOfSemocolon != 3)
                    {
                        if (currentLine[currentSymbol] == ';')
                        {
                            numberOfSemocolon++;
                        }
                        currentSymbol++;
                    }
                    while (currentLine[currentSymbol] != ';')
                    {

                        currentDateString += currentLine[currentSymbol];

                        currentSymbol++;
                    }

                    currentDateString += " ";
                    currentSymbol++;
                    currentHour += currentLine[currentSymbol];
                    currentHour += currentLine[currentSymbol + 1];
                    while (currentLine[currentSymbol] != ',')
                    {
                        currentDateString += currentLine[currentSymbol];

                        currentSymbol++;
                    }
                    DateTime.TryParse(currentDateString, out currentDate);
                    if (!vector.ContainsKey(currentDate.DayOfWeek.ToString()))
                    {
                        List<double> myList = new List<double>();
                        myList.Add(Convert.ToDouble(currentTymeOfExecution));
                        new List<double>().Add(Convert.ToDouble(currentTymeOfExecution));
                        Dictionary<String, List<double>> addDictionary = new Dictionary<string, List<double>>();
                        addDictionary.Add(currentHour, myList);
                        vector.Add(currentDate.DayOfWeek.ToString(), addDictionary);
                    }
                    else
                    {
                        if (!vector[currentDate.DayOfWeek.ToString()].ContainsKey(currentHour))
                        {
                            List<double> myList = new List<double>();
                            myList.Add(Convert.ToDouble(currentTymeOfExecution));
                            vector[currentDate.DayOfWeek.ToString()].Add(currentHour, myList);
                        }
                        else
                        {
                            vector[currentDate.DayOfWeek.ToString()][currentHour].Add(Convert.ToDouble(currentTymeOfExecution));
                        }
                    }
                    numberOfSemocolon = 0;
                    currentSymbol = 0;
                    currentTymeOfExecution = String.Empty;
                    currentDateString = string.Empty;
                    currentHour = string.Empty;
                }
                currentSymbol = 0;
            }
            if (vector.ContainsKey("Monday"))
            {
                if (vector["Monday"].ContainsKey("00"))
                {
                    vectorOfQuery.Add(vector["Monday"]["00"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("01"))
                {
                    vectorOfQuery.Add(vector["Monday"]["01"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("02"))
                {
                    vectorOfQuery.Add(vector["Monday"]["02"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("03"))
                {
                    vectorOfQuery.Add(vector["Monday"]["03"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("04"))
                {
                    vectorOfQuery.Add(vector["Monday"]["04"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("05"))
                {
                    vectorOfQuery.Add(vector["Monday"]["05"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("06"))
                {
                    vectorOfQuery.Add(vector["Monday"]["06"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("07"))
                {
                    vectorOfQuery.Add(vector["Monday"]["07"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("08"))
                {
                    vectorOfQuery.Add(vector["Monday"]["08"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("09"))
                {
                    vectorOfQuery.Add(vector["Monday"]["09"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("10"))
                {
                    vectorOfQuery.Add(vector["Monday"]["10"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("11"))
                {
                    vectorOfQuery.Add(vector["Monday"]["11"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("12"))
                {
                    vectorOfQuery.Add(vector["Monday"]["12"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("13"))
                {
                    vectorOfQuery.Add(vector["Monday"]["13"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("14"))
                {
                    vectorOfQuery.Add(vector["Monday"]["14"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("15"))
                {
                    vectorOfQuery.Add(vector["Monday"]["15"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("16"))
                {
                    vectorOfQuery.Add(vector["Monday"]["16"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("17"))
                {
                    vectorOfQuery.Add(vector["Monday"]["17"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("18"))
                {
                    vectorOfQuery.Add(vector["Monday"]["18"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("19"))
                {
                    vectorOfQuery.Add(vector["Monday"]["19"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("20"))
                {
                    vectorOfQuery.Add(vector["Monday"]["20"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("21"))
                {
                    vectorOfQuery.Add(vector["Monday"]["21"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("22"))
                {
                    vectorOfQuery.Add(vector["Monday"]["22"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
                if (vector["Monday"].ContainsKey("23"))
                {
                    vectorOfQuery.Add(vector["Monday"]["23"].Sum());
                }
                else
                {
                    vectorOfQuery.Add(0);
                }
            }
            return vectorOfQuery;
        }

        private static List<double> CreateVectorByDayOfWeek(string queryId)
        {
            Dictionary<string, List<double>> vector = new Dictionary<string, List<double>>();
            List<double> vectorOfQuery = new List<double>(7);
            StreamReader inputData = new StreamReader("inputData.txt");

            string currentLine = String.Empty;
            int numberOfSemocolon = 0;
            int currentSymbol = 0;

            DateTime currentDate = new DateTime();
            string currentDateString = String.Empty;

            string currentTymeOfExecution = String.Empty;

            while ((currentLine = inputData.ReadLine()) != null)
            {
                while (currentSymbol < queryId.Length && currentLine[currentSymbol] == queryId[currentSymbol])
                {
                    currentSymbol++;
                }
                if (currentSymbol == queryId.Length)
                {
                    currentSymbol++;
             
                    if (currentLine[currentSymbol] == '.')
                    {
                        currentTymeOfExecution += '0';
                    }
                    while (currentLine[currentSymbol] != ';')
                    {
                        if (currentLine[currentSymbol] == '.')
                        {
                            currentTymeOfExecution += ',';
                        }
                        else
                        {
                            currentTymeOfExecution += currentLine[currentSymbol];
                        }
                        currentSymbol++;
                    }

                    while (numberOfSemocolon != 3)
                    {
                        if (currentLine[currentSymbol] == ';')
                        {
                            numberOfSemocolon++;
                        }
                        currentSymbol++;
                    }
                    while (currentLine[currentSymbol] != ';')
                    {

                        currentDateString += currentLine[currentSymbol];

                        currentSymbol++;
                    }

                    currentDateString += " ";
                    currentSymbol++;
                    while (currentLine[currentSymbol] != ',')
                    {

                        currentDateString += currentLine[currentSymbol];

                        currentSymbol++;
                    }
                    DateTime.TryParse(currentDateString, out currentDate);

                    if (!vector.ContainsKey(currentDate.DayOfWeek.ToString()))
                    {
                        List<double> myList = new List<double>();
                        myList.Add(Convert.ToDouble(currentTymeOfExecution));
                        new List<double>().Add(Convert.ToDouble(currentTymeOfExecution));
                        vector.Add(currentDate.DayOfWeek.ToString(), myList);
                    }
                    else
                    {

                        vector[currentDate.DayOfWeek.ToString()].Add(Convert.ToDouble(currentTymeOfExecution));
                    }
                    numberOfSemocolon = 0;
                    currentSymbol = 0;
                    currentTymeOfExecution = String.Empty;
                    currentDateString = string.Empty;
                }
                currentSymbol = 0;
            }
            if (vector.ContainsKey("Monday"))
            {
                vectorOfQuery.Add(vector["Monday"].Sum());
            }
            else
            {
                vectorOfQuery.Add(0);
            }
            if (vector.ContainsKey("Tuesday"))
            {
                vectorOfQuery.Add(vector["Tuesday"].Sum());
            }
            else
            {
                vectorOfQuery.Add(0);
            }
            if (vector.ContainsKey("Wednesday"))
            {
                vectorOfQuery.Add(vector["Wednesday"].Sum());
            }
            else
            {
                vectorOfQuery.Add(0);
            }
            if (vector.ContainsKey("Thursday"))
            {
                vectorOfQuery.Add(vector["Thursday"].Sum());
            }
            else
            {
                vectorOfQuery.Add(0);
            }
            if (vector.ContainsKey("Friday"))
            {
                vectorOfQuery.Add(vector["Friday"].Sum());
            }
            else
            {
                vectorOfQuery.Add(0);
            }
            if (vector.ContainsKey("Saturday"))
            {
                vectorOfQuery.Add(vector["Saturday"].Sum());
            }
            else
            {
                vectorOfQuery.Add(0);
            }
            if (vector.ContainsKey("Sunday"))
            {
                vectorOfQuery.Add(vector["Sunday"].Sum());
            }
            else
            {
                vectorOfQuery.Add(0);
            }
            return vectorOfQuery;
        }

        private static List<double> CreateVector(string queryId)
        {
            List<double> vectorOfQuery = new List<double>();
            StreamReader inputData = new StreamReader("inputData.txt");

            DateTime currentDate = new DateTime();
            DateTime previousDate = new DateTime(2011, 7, 16, 21, 0, 0);
            string currentLine = String.Empty;
            int diffInHour = 0;
            int numberOfSemocolon = 0;
            int currentSymbol = 0;

            string currentDateString = String.Empty;
            string currentTymeOfExecution = String.Empty;

            while ((currentLine = inputData.ReadLine()) != null)
            {
                while (currentSymbol < queryId.Length && currentLine[currentSymbol] == queryId[currentSymbol])
                {
                    currentSymbol++;
                }
                if (currentSymbol == queryId.Length)
                {
                    currentSymbol++;
                    if (currentLine[currentSymbol] == '.')
                    {
                        currentTymeOfExecution += '0';
                    }
                    while (currentLine[currentSymbol] != ';')
                    {
                        if (currentLine[currentSymbol] == '.')
                        {
                            currentTymeOfExecution += ',';
                        }
                        else
                        {
                            currentTymeOfExecution += currentLine[currentSymbol];
                        }
                        currentSymbol++;
                    }

                    while (numberOfSemocolon != 3)
                    {
                        if (currentLine[currentSymbol] == ';')
                        {
                            numberOfSemocolon++;
                        }
                        currentSymbol++;
                    }

                    while (currentLine[currentSymbol] != ';')
                    {

                        currentDateString += currentLine[currentSymbol];

                        currentSymbol++;
                    }

                    currentDateString += " ";
                    currentSymbol++;
                    while (currentLine[currentSymbol] != ':')
                    {

                        currentDateString += currentLine[currentSymbol];

                        currentSymbol++;
                    }
                    currentDateString += ":00:00";
                    DateTime.TryParse(currentDateString, out currentDate);

                    diffInHour = (int)currentDate.Subtract(previousDate).TotalHours;

                    if (diffInHour == 0)
                    {
                        if (Convert.ToDouble(currentTymeOfExecution) > 0)
                        {
                            vectorOfQuery[vectorOfQuery.Count - 1] = Convert.ToDouble(currentTymeOfExecution);
                        }

                    }
                    else
                    {
                        while (diffInHour > 1)
                        {
                            vectorOfQuery.Add(0);
                            diffInHour--;
                        }

                        previousDate = currentDate;
                        vectorOfQuery.Add(Convert.ToDouble(currentTymeOfExecution));
                    }
                    numberOfSemocolon = 0;
                    currentSymbol = 0;
                    currentTymeOfExecution = String.Empty;
                    currentDateString = string.Empty;
                }
                currentSymbol = 0;
            }
            diffInHour = (int)endDate.Subtract(currentDate).TotalHours;
            while (diffInHour > 0)
            {
                vectorOfQuery.Add(0);
                diffInHour--;
            }
            return vectorOfQuery;
        }

        static void Main(string[] args)
        {

            string values = string.Empty;
            string currentLine = String.Empty;
            int currentSymbol = 0;
            string queryId = String.Empty;

            StreamReader inputDataOp = new StreamReader("inputData2.txt");

            outputData.WriteLine("@relation query");
            for (int i = 0; i < 7; i++)
            {
                outputData.WriteLine("@attribute dayOfWeek{0} numeric", i);
            }
            outputData.WriteLine();
            outputData.WriteLine("@data");
            outputData.WriteLine();
            while ((currentLine = inputDataOp.ReadLine()) != null)
            {
                while (currentLine[currentSymbol] != ';')
                {
                    queryId += currentLine[currentSymbol];
                    currentSymbol++;
                }
                if (!listOfVectorsForQuery.ContainsKey(queryId))
                {
                    listOfVectorsForQuery.Add(queryId, CreateVector(queryId));
                }
                queryId = string.Empty;
                currentSymbol = 0;
            }

            ReduceNoActiveQuery();

            ReduceRegularQuery();

            Normalization();


            foreach (KeyValuePair<string, List<double>> pair in listOfVectorsForQuery)
            {
                listOfVectorOutput.Write(pair.Key + ' ');
                foreach (double value in pair.Value)
                {
                    values = Convert.ToString(value);
                    for (int i = 0; i < values.Length; i++)
                    {
                        listOfVectorOutput.Write(values[i]);
                    }
                    if (globalCount != 2386)
                    {
                        listOfVectorOutput.Write(' ');
                    }
                    values = String.Empty;
                    globalCount++;
                }
                globalCount = 0;
                listOfVectorOutput.WriteLine();
            }
            listOfVectorOutput.Close();
            Normalization();
            foreach (KeyValuePair<string, List<double>> pair in listOfVectorsForQuery)
            {
                outputData.Write(pair.Key + ' ');
                foreach (double value in pair.Value)
                {
                    values = Convert.ToString(value);
                    for (int i = 0; i < values.Length; i++)
                    {
                        if (values[i] == ',')
                        {
                            outputData.Write('.');
                        }
                        else
                        {
                            outputData.Write(values[i]);
                        }
                    }
                    if (globalCount != 2386)
                    {
                        outputData.Write(' ');
                    }
                    values = String.Empty;
                    globalCount++;
                }
                globalCount = 0;
                outputData.WriteLine();
            }
            outputData.Close();
        }
    }
}

